# Server configuration
server {
    listen *:{{ nginx_porta }};
    listen [::]:{{ nginx_porta }};

    server_name {{ nginx_nome }};
    root /var/www/{{ nginx_nome }};
    index index.html index.htm index.php;

    # Logs nginx
    access_log /var/log/nginx/{{ nginx_nome }}_access.log;
    error_log /var/log/nginx/{{ nginx_nome }}_error.log;

    #fastcgi_cache start
    set $no_cache 0;

    # POST requests and urls with a query string should always go to PHP
    if ($request_method = POST) {
            set $no_cache 1;
    }   
    if ($query_string != "") {
            set $no_cache 1;
    }    

    # Don't cache uris containing the following segments
    if ($request_uri ~* "(/wp-admin/|/xmlrpc.php|/wp-(app|cron|login|register|mail).php|wp-.*.php|/feed/|index.php|wp-comments-popup.php|wp-links-opml.php|wp-locations.php|sitemap(_index)?.xml|[a-z0-9_-]+-sitemap([0-9]+)?.xml)") {
            set $no_cache 1;
    }   

    # Don't use the cache for logged in users or recent commenters
    if ($http_cookie ~* "comment_author|wordpress_[a-f0-9]+|wp-postpass|wordpress_no_cache|wordpress_logged_in") {
            set $no_cache 1;
    } 

{% if tipo_wp ==  "multisite" %}
    location ~ ^(/[^/]+)?/files/(.+) {
        try_files /wp-content/blogs.dir/$blogid/files/$2 /wp-includes/ms-files.php?file=$2 ;
        access_log off;     log_not_found off; expires max;
    }

    #avoid php readfile()
    location ^~ /blogs.dir {
        internal;
        alias /var/www/example.com/htdocs/wp-content/blogs.dir ;
        access_log off;     log_not_found off; expires max;
    }

    if (!-e $request_filename) {
        rewrite /wp-admin$ $scheme://$host$uri/ permanent;
        rewrite ^(/[^/]+)?(/wp-.*) $2 last;
        rewrite ^(/[^/]+)?(/.*\.php) $2 last;
    }
{% endif %}

    location / {
	try_files $uri $uri/ /index.php?$query_string;
	if ($args ~ "^author=\d") { return 301 http://{{ nginx_nome }}:{{ nginx_porta }}; }
    }


    location ~ \.php$ {

        location ~ \wp-login.php$ {
            fastcgi_pass unix:/run/php/php8.2-fpm.sock;
            fastcgi_intercept_errors on;
        }

        include snippets/fastcgi-php.conf;
        include fastcgi_params;

        fastcgi_split_path_info ^(.+?\.php)(\/.*|)$;
        fastcgi_param SCRIPT_FILENAME $document_root$fastcgi_script_name;
        fastcgi_param PATH_INFO $path_info;
        fastcgi_param HTTPS on;
        # Avoid sending the security headers twice
        fastcgi_param modHeadersAvailable true;
        # Enable pretty urls
        fastcgi_param front_controller_active true;
        fastcgi_pass unix:/run/php/php8.2-fpm.sock;
        fastcgi_intercept_errors on;
        # Buffering
        fastcgi_request_buffering off;
        fastcgi_buffer_size          128k;
        fastcgi_buffers              4 256k;
        fastcgi_busy_buffers_size    256k;
        fastcgi_connect_timeout      90;
        fastcgi_send_timeout         90;
        fastcgi_read_timeout         90;
	# Cache
        fastcgi_cache_bypass $no_cache;
        fastcgi_no_cache $no_cache;

        fastcgi_cache WORDPRESS;
        fastcgi_cache_valid 200 60m;
    }

    if (!-e $request_filename) {
	rewrite /wp-admin$ $scheme://$host$uri/ permanent;
	rewrite ^(/[^/]+)?(/wp-.*) $2 last;
        rewrite ^(/[^/]+)?(/.*.php) $2 last;
    }


    # Global restrictions configuration file.
    # Designed to be included in any server {} block.
    location = /favicon.ico {
       log_not_found off;
       access_log off;
    }

    location = /robots.txt {
       allow all;
       log_not_found off;
       access_log off;
    }

    # Deny all attempts to access hidden files such as .htaccess, .htpasswd, .DS_Store (Mac).
    # Keep logging the requests to parse later (or to pass to firewall utilities such as fail2ban)
    location ^~ /\.ht {
        deny all;
        error_page 403 =404 / ;
    }

    # Block XMLRPC
    location ^~ /xmlrpc.php {
        deny all;
        error_page 403 =404 / ;
    }

    # Deny access to any files with a .php extension in the uploads directory
    # Works in sub-directory installs and also in multisite network
    # Keep logging the requests to parse later (or to pass to firewall utilities such as fail2ban)
    location ~* /(?:uploads|files)/.*\.php$ {
       deny all;
    }

    location ~* ^/wp-content/plugins/.+\.(txt|log|md)$ {
        deny all;
        error_page 403 =404 / ;
    }

}



{% if tipo_wp ==  "multisite" %}
map $uri $blogname{
    ~^(?P<blogpath>/[^/]+/)files/(.*)       $blogpath ;
}

map $blogname $blogid{
    default -999;

    #Ref: http://wordpress.org/extend/plugins/nginx-helper/
    #include /var/www/wordpress/wp-content/plugins/nginx-helper/map.conf ;
}
{% endif %}



